# Class BasicColorChooserUI

java.lang.Object
javax.swing.plaf.ComponentUI
javax.swing.plaf.ColorChooserUI
javax.swing.plaf.basic.BasicColorChooserUI

Direct Known Subclasses:
  `SynthColorChooserUI`

public class BasicColorChooserUI extends ColorChooserUI
Provides the basic look and feel for a JColorChooser.

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`class`
`BasicColorChooserUI.PropertyHandler`
This class should be treated as a "protected" inner class.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected JColorChooser`
`chooser`
JColorChooser this BasicColorChooserUI is installed on.
`protected AbstractColorChooserPanel[]`
`defaultChoosers`
The array of default color choosers.
`protected ChangeListener`
`previewListener`
The instance of `ChangeListener`.
`protected PropertyChangeListener`
`propertyChangeListener`
The instance of `PropertyChangeListener`.

## Constructor Summary

Constructors
Constructor
Description
`BasicColorChooserUI()`
Constructs a `BasicColorChooserUI`.

## Method Summary

Modifier and Type
Method
Description
`protected AbstractColorChooserPanel[]`
`createDefaultChoosers()`
Returns an array of default color choosers.
`protected PropertyChangeListener`
`createPropertyChangeListener()`
Returns an instance of `PropertyChangeListener`.
`static ComponentUI`
`createUI(JComponent c)`
Returns a new instance of `BasicColorChooserUI`.
`protected void`
`installDefaults()`
Installs default properties.
`protected void`
`installListeners()`
Registers listeners.
`protected void`
`installPreviewPanel()`
Installs preview panel.
`protected void`
`uninstallDefaultChoosers()`
Uninstalls default color choosers.
`protected void`
`uninstallDefaults()`
Uninstalls default properties.
`protected void`
`uninstallListeners()`
Unregisters listeners.
`protected void`
`uninstallPreviewPanel()`
Removes installed preview panel from the UI delegate.

### Methods declared in class ComponentUI

`contains, getAccessibleChild, getAccessibleChildrenCount, getBaseline, getBaselineResizeBehavior, getMaximumSize, getMinimumSize, getPreferredSize, installUI, paint, uninstallUI, update`
Modifier and Type
Method
Description
`boolean`
`contains(JComponent c, int x, int y)`
Returns `true` if the specified x,y location is contained within the look and feel's defined shape of the specified component.
`Accessible`
`getAccessibleChild(JComponent c, int i)`
Returns the `i`th `Accessible` child of the object.
`int`
`getAccessibleChildrenCount(JComponent c)`
Returns the number of accessible children in the object.
`int`
`getBaseline(JComponent c, int width, int height)`
Returns the baseline.
`Component.BaselineResizeBehavior`
`getBaselineResizeBehavior(JComponent c)`
Returns an enum indicating how the baseline of the component changes as the size changes.
`Dimension`
`getMaximumSize(JComponent c)`
Returns the specified component's maximum size appropriate for the look and feel.
`Dimension`
`getMinimumSize(JComponent c)`
Returns the specified component's minimum size appropriate for the look and feel.
`Dimension`
`getPreferredSize(JComponent c)`
Returns the specified component's preferred size appropriate for the look and feel.
`void`
`installUI(JComponent c)`
Configures the specified component appropriately for the look and feel.
`void`
`paint(Graphics g, JComponent c)`
Paints the specified component appropriately for the look and feel.
`void`
`uninstallUI(JComponent c)`
Reverses configuration which was done on the specified component during `installUI`.
`void`
`update(Graphics g, JComponent c)`
Notifies this UI delegate that it is time to paint the specified component.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Field Details

### chooser

protected JColorChooser chooser
JColorChooser this BasicColorChooserUI is installed on.

Since:
  1.5

### defaultChoosers

protected AbstractColorChooserPanel[] defaultChoosers
The array of default color choosers.

### previewListener

protected ChangeListener previewListener
The instance of `ChangeListener`.

### propertyChangeListener

protected PropertyChangeListener propertyChangeListener
The instance of `PropertyChangeListener`.

## Constructor Details

### BasicColorChooserUI

public BasicColorChooserUI()
Constructs a `BasicColorChooserUI`.

## Method Details

### createUI

public static ComponentUI createUI(JComponent c)
Returns a new instance of `BasicColorChooserUI`.

Parameters:
  `c` - a component
Returns:
  a new instance of `BasicColorChooserUI`

### createDefaultChoosers

protected AbstractColorChooserPanel[] createDefaultChoosers()
Returns an array of default color choosers.

Returns:
  an array of default color choosers

### uninstallDefaultChoosers

protected void uninstallDefaultChoosers()
Uninstalls default color choosers.

### installPreviewPanel

protected void installPreviewPanel()
Installs preview panel.

### uninstallPreviewPanel

protected void uninstallPreviewPanel()
Removes installed preview panel from the UI delegate.

Since:
  1.7

### installDefaults

protected void installDefaults()
Installs default properties.

### uninstallDefaults

protected void uninstallDefaults()
Uninstalls default properties.

### installListeners

protected void installListeners()
Registers listeners.

### createPropertyChangeListener

protected PropertyChangeListener createPropertyChangeListener()
Returns an instance of `PropertyChangeListener`.

Returns:
  an instance of `PropertyChangeListener`

### uninstallListeners

protected void uninstallListeners()
Unregisters listeners.